;               (c) 1990 by IgOR BOCHAROV.
;
;---------------    ---------------------------
;
cr      EQU     13              ;  " "
Up      EQU     30              ;  
Down    EQU     31              ;  
TheBeg  EQU     0DC00h          ;    .
GetHL   EQU     2F8Ah           ;   .
PutHL   EQU     2F99h
Base1   EQU     0F3B5h          ;  .  . .
CsrX    EQU     0F3DDh          ;  LOCATE  X
CsrY    EQU     0F3DCh          ;   Y
RdVram  EQU     004Ah           ;   VRAM
WrVrHL  EQU     004Dh           ;   VRAM
SetWrt  EQU     0053h           ;  VDP  
ChSns   EQU     009Ch           ;    .
ChGet   EQU     009Fh           ;    
BreakX  EQU     00B7h           ;  <CTRL>+<Stop>
;--------------------------------------------------------------
        ORG     TheBeg
;-------------------   ------------------------------
        JP      Menu            ;  
        JP      ClMenu          ;   
;--------------    -------------------------
Menu:   CALL    GetHL           ; [HL] -   
        PUSH    HL              ;   
        LD      IY,Variab       ;   
        XOR     a               ;  
        LD      (IY+dy),a       ;  
        LD      (IY+dx),a       ; dx
l001:   LD      a,(HL)          ;   
        AND     a               ; ?
        JR      Z,l002          ;  ,  
        INC     (IY+dy)         ;   
        INC     HL              ; + 
        INC     HL              ; + 
        INC     HL
        CP      (IY+dx)         ;  dx?
        JR      C,l001          ;  ,  dx  
        LD      (IY+dx),A
        JR      l001
;---------------    --------------------
l002:   LD      HL,(CsrY)       ; x y
        DEC     H
        DEC     L
        LD      C,H             ; x
        LD      B,0
        LD      H,B
        ADD     HL,HL           ; * 2
        ADD     HL,HL           ; * 4
        ADD     HL,HL           ; * 8
        ADD     HL,HL           ; * 16
        LD      E,L
        LD      D,H
        ADD     HL,HL           ; * 32
        ADD     HL,HL           ; * 64
        ADD     HL,DE           ; * 80
        ADD HL,BC
        EX      DE,HL
        INC     (IY+dx)         ; dx
        INC     (IY+dx)         ; dx
        LD      b,(IY+dx)       ; dx
        LD      c,(IY+dy)       ; dy
        PUSH    DE              ;   
;-------------------   ------------------------------
; [DE] - x + y*80, [b] - dx, [c] - dy
        PUSH    BC
        PUSH    DE              ;  
;   
        LD      a,17h           ;  
        LD      HL,1819h        ;  
        CALL    WndL01
WndL02:
        LD      a,' '           ; ' '
        LD      HL,1616h        ;  
        CALL    WndL01
        DEC     c
        JR      NZ,WndL02
        LD      a,17h           ;  
        LD      HL,1A1Bh        ;  
        CALL    WndL01
;---   -------------
NEXtColORInWindow:
        POP     HL              ; x,y
        POP     DE              ; dx,dy
        INC     D
        INC     D
        INC     D               ; dx = dx + 4
        INC     D
        INC     E               ; dy = dy + 2
        INC     E
WndLp1:
        PUSH    DE
        PUSH    HL
        CALL    FillColORTable  ;  
        POP     HL
        LD      DE,80           ; [y] = [y] + 1
        ADD     HL,DE
        POP     DE
        DEC     E               ; [dy] = [dy] - 1
        JR      NZ,WndLp1
;-------------------     -----------------------
        POP     HL
        LD      DE,80*1+3       ;   
        ADD     HL,DE
        LD      D,H
        LD      E,L
        EX      (SP),HL         ;   
l003:   LD      A,(HL)          ;   
        AND     A               ; ?
        JR      Z,l004          ;  ,  
        LD      B,A             ;  dx
        PUSH    HL
        PUSH    DE
        DI
        LD      A,E             ;   
        OUT     (99h),A
        LD      A,D             ;   
        OR      40h             ;  6   1
        OUT     (99h),A
        INC     HL
        LD      A,(HL)          ;   
        INC     HL
        LD      H,(HL)
        LD      L,A
        LD      C,98h           ;    VDP
        OTIR                    ;  
        EI
        POP     HL
        LD      DE,80
        ADD     HL,DE
        EX      DE,HL           ; [DE] -  
        POP     HL
        INC     HL
        INC     HL
        INC     HL
        JR      l003            ;  
;-------------------    -----------------------------
l004:   POP     HL              ;   
        LD      C,0             ;  
        LD      D,C
        LD      E,D
l007:   PUSH    HL
l008:   ADD     HL,DE
        CALL    RdVram
        CP      ' '             ; ?
        JR      NZ,l006
        LD      DE,80
        JR      l008
l006:   POP     DE
        CP      17h             ; ?
        JR      NZ,l009
        EX      DE,HL
        DEC     C
l009:   INC     C
        PUSH    BC              ; 
        PUSH    HL              ;  
        LD      D,(IY+dx)
        DEC     HL
        CALL    ClearColORTable
        POP     HL
        POP     BC
;-------------------
InputKey:
        CALL    BreakX
        JR      NC,Input
        LD      C,0
        JR      Exit
Input:  CALL    ChSns           ;  -  ?
        JR      Z,Inputkey
        CALL    ChGet           ;  
;-------------------
        CP      cr
        JR      NZ,CheckUp
        LD      A,''
        DEC     HL
        CALL    WrVrHL
Exit:   LD      H,0
        LD      L,C             ;  
        JP      PutHL
;-------------------
CheckUp:
        CP      Up
        JR      NZ,CheckDown
        LD      A,C
        DEC     A               ;    ?
        JR      Z,InputKey
        LD      C,A
        PUSH    BC
        PUSH    HL
        LD      D,(IY+dx)
        DEC     HL
        CALL    FillColORTable  ;  
        POP     HL
        LD      DE,-80          ;    
l010:   ADD     HL,DE           ;   
        CALL    RdVram
        CP      ' '
        JR      Z,l010          ;  
        LD      D,(IY+dx)
        PUSH    HL
        DEC     HL
        CALL    ClearColORTable
        POP     HL
        POP     BC
        JR      InputKey
;-------------------
CheckDown:CP    Down
        JR      NZ,InputKey
        PUSH    HL
        LD      D,(IY+dx)
        PUSH    BC
        DEC     HL
        CALL    FillColORTable  ;  
        POP     BC
        POP     HL
        LD      DE,80
        JR      l007
;--------------------------------------------------------------
WndL01:
        PUSH    BC
        PUSH    DE
        PUSH    AF
        PUSH    BC
        LD      A,' '
        CALL    WrVram
        LD      A,H
        CALL    WrVram
        POP     BC
        POP     AF
        CALL    FillVm
        LD      A,L
        CALL    WrVram
        LD      A,' '
        CALL    WrVram
        POP     HL
        LD      BC,80
        ADD     HL,BC
        EX      DE,HL
        POP     BC
        RET
;--------------------------------------------------------------
;       
; [HL] - y *80+ x; [d] - dx
; MoDIfy: AF, BC, DE, HL
FillColORTable:
        LD      E,10000000b
        CALL    GetMaskColOR    ;    
WndLp4: CALL    RdVram          ;   
WndLp3: OR      E
        DEC     D               ; [dx] = [dx] - 1
        JP      z,WrVrHL
        RRC     E               ;  
        JR      NC,WndLp3       ;     ,  
                                ; 
        CALL    WrVrHL          ;  
        INC     HL              ;   VRAM
        JR      WndLp4
;--------------------------------------------------------------
;   
; [HL] - y *80+ x; [d] - dx
; MoDIfy: AF, BC, DE, HL
ClearColORTable:
        LD      E,01111111b
        CALL    GetMaskColOR    ;   VRAM  
WndLp5: CALL    RdVram          ;   
WndLp6: AND     E
        DEC     D               ; [dx] = [dx] - 1
        JP      Z,WrVrHL
        RRC     E               ;  
        JR      C,WndLp6        ;     ,  
                                ; 
        CALL    WrVrHL          ;  
        INC     HL              ;   VRAM
        JR      WndLp5
;--------------------------------------------------------------
;     VRAM  
; [HL] - y*80 + x;
; [HL] -  Vram; [e] - 
GetMaskColOR:
        LD      A,L             ;   . . 
        LD      B,3
        SRL     H               ; [HL] = [HL] / 8
        RR      L
        DJNZ    $-4
        LD      BC,(Base1)
        ADD     HL,BC           ;   VRAM
        CPl                     ; [a] = not([a])
        AND     00000111b       ; ,   
        LD      B,A
        INC     B
        RLC     E
        DJNZ    $-2
        RET
;--------------------------------------------------------------
;   
                               
ClMenu: LD      DE,(Base1)
        LD      B,24*10
        XOR     A
;--------------------------------------------------------------
;  VRAM const [a], len [b], adr [DE]
FillVm: DI
        PUSH    AF
        LD      A,E
        OUT     (99h),A
        LD      A,D
        OR      40h
        OUT     (99h),A
        POP     AF
        EX      (SP),HL
        EX      (SP),HL
        OUT     (98h),A
        INC     DE
        djNZ    $-3             ; ,  
        RET
;--------------------------------------------------------------
WrVram: EX      DE,HL
        CALL    WrVrHL
        EX      DE,HL
        INC     DE
        RET
;--------------------------------------------------------------
Variab  EQU     $
dy      EQU     1
dx      EQU     2
        END
